#ifndef _LIBUDF_H_
#define _LIBUDF_H_

/****************************************************************************
 * this header is used for user to create external udf only
 ****************************************************************************/

#include <stdlib.h> 

typedef unsigned char      i8;              /* 1 byte unsigned */
typedef short              i15;             /* 2 byte signed   */
typedef unsigned short     i16;             /* 2 byte unsigned */
typedef long               i31;             /* 4 byte signed   */
typedef unsigned long      i32;             /* 4 byte unsigned */

typedef struct
{
    i8 pre;
    i8 sca;
    i8 dgt[20]; 
    i8 exp; 
	i8 juk;    
} dec_t10;

typedef dec_t10   dec_t;

typedef struct tVAL {
   i16 type;                   /* data type          */
   i15 len;                    /* data length        */
   union {
      i31    ival;             /* long integer data  */
      i15    sival;            /* short integer data */
      double fval;             /* double data        */
      float  sfval;            /* float data         */
      dec_t  dval;             /* decimal data       */
      char   *xval;            /* pointer to data    */
   } u;
} VAL;

#define BBOBJ_SIZE 24 

typedef struct tBBObj {
  char s[BBOBJ_SIZE];
} BBObj;

/****************************************************************************
 * column types
****************************************************************************/
#define BIN_TYP   0x0000                   /* bit string     data type*/
#define CHAR_TYP  0x1000                   /* character      data type*/
#define INT_TYP   0x2000                   /* integer        data type*/
#define FLT_TYP   0x3000                   /* floating point data type*/
#define OID_TYP   0x4000                   /* OID            data type*/
#define BLOB_TYP  0x5000                   /* blob           data type*/
#define DEC_TYP   0x6000                   /* decimal        data type*/
#define NCHAR_TYP 0x9000                   /* national char  data type*/
#define NULL_TYP  0xF000                   /* set if column is null   */

/****************************************************************************
 *  seek option 
 ***************************************************************************/
#define SEEK_BB_BEG   0x01
#define SEEK_BB_CUR   0x02
#define SEEK_BB_END   0x04

/****************************************************************************
 * function prototypes
****************************************************************************/
int _UDFAllocMem(VAL *Arg, char **ppt, int nb);
int _RetVal(VAL *Arg, VAL rtn);
int _UDFBbOpen(VAL *Arg, BBObj bbObj, i31 *pHandle);
int _UDFBbRead(VAL *Arg, i31 handle, i31 szBuf, i31 *szRead, char *pBuf);
int _UDFBbSeek(VAL *Arg, i31 handle, i31 offset, i16 ptrname);
int _UDFBbClose(VAL *Arg, i31 handle);
int _UDFBbCreate(VAL *Arg, BBObj *pBbObj, i31 *pHandle, i31 Opt);
int _UDFBbWrite(VAL *Arg, i31 handle, i31 szBuf, char *pBuf);
int _UDFBbCurOffset(VAL *Arg, i31 handle, i31 *pOffset);
int _UDFBbSize(VAL *Arg, BBObj bbObj, i31 *pLen);
int _UDFBbDrop(VAL *Arg, BBObj bbObj);

#endif /* _LIBUDF_H */
